//************************************************************************************************
// This is the main dll header file that you will need to incorporate into your calling program
// if you are going to statically link it.
//
// This file should be universal for any 'Optimus' Type GUI interfaces and should not differ
// from test type to test type.
//
//
//************************************************************************************************
#ifndef DLL_H    // standard protection against multiple inclusion
#define DLL_H


//----- Structure used as input argument to the dlls -----//
typedef struct 
{	
	int (*pt2OutFunction)(int, char *Text,...) ;  //callback function for Text data - supceeded with XML data
	int (*pt2LEDFunction)(int ,int ); //callback for LED calls back to GUI
	int *TestArray;
	int *LoopArray;
	char *Barcode;
	char *SubParts;
	char *Concessions;
	char *TestCode;

        //Additional info for XML logging compatability - added 4/3/10 RM
        char *Operator;
        char *TestRigBarcode;
        int *NumberOfRetries;
        char *RetryReason;
        char *RMA;
        int *RMALoop;

        char *pMessageClassName; //pointer to the class name used for passing the gui message data

        //Added v 4.0 for MDW Outsourcing
        char *LogFilePath;
        char *LogFileName;
} DLL_args;



#if defined(__cplusplus)


extern "C"
{
#endif
__declspec(dllexport) int TestEntry(DLL_args dllargs);
__declspec(dllexport) int DLL_Version(double *version);
#if defined(__cplusplus)

}

#endif
#endif
