//*******************************************************************************************//
//  Filename:
//  Created on:
// 	Copyright:   	Xyratex. All Rights Reserved.
//  Description:        main!
//
//  History:
//-------------------------------------------------------------------------------------------
//      Software     Modification    Eng     Detail
//      Version      Date
//      1.0          01/05/07              First release
//******************************************************************************************//
#include <sys\types.h>
#include <system.hpp>
#include <process.h>
#include <vcl.h>
#include <Dialogs.hpp>

#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <io.h>


#include "vcl.h"
#include "defs.h"
#include "error_codes.h"
#include "XMLDataLogger.h"
#include "test.h"
#include "dll.h"
#include "main.h"

#include "xylogger.h"

#include "Serial_dll.h"

//Global Variables go here....
Xy_XML_Data_Logger* pXMLLogger=NULL;
AnsiString Part_Number;     //should be 1234567-01 format (plus null)
AnsiString Serial_Number;   //should be 6 hex chars (plus null)
time_t starttime,endtime;  //to work out tottal test time for log file

//ASSUMPTIONS
//
//1.  pXMLLogger->WriteDebugRecord("BLAH");  I wont check for return codes on debug as its just
//textual stuff that is not really needed.
//
//2. Any failures of anysort in a test will be overwritted with a generic test failure code for that test
//  (You can change this is you like!).


//=================================================================================//
// Function 		:	DllMain
// Description		:	This is the entry function guaranteed to be implemented
//=================================================================================//
int __stdcall DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	switch(fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            break;

        case DLL_THREAD_ATTACH:
            break;

        case DLL_THREAD_DETACH:
            break;

        case DLL_PROCESS_DETACH:
            break;
        }
        return 1;
}


//=================================================================================//
// Function 		:	DllEntryPoint
// Description		:	For Borland Compatibility.
//=================================================================================//
int __stdcall DllEntryPoint (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	return DllMain (hinstDLL, fdwReason, lpvReserved);
}

//=================================================================================//
// Function 		:	DLL_Version
// Description		:	Get DLL version
//=================================================================================//
int DLL_Version(double *version)
{
	*version = DLL_VERSION_NUMBER;
	return 0;
}

//=================================================================================//
// Function 		:	TestEntry
// Description		:	This is the entry function guaranteed to be implemented
// 					:	it is used as a common entry point from the Gui for testing .
// Inputs			:	pointer to the OutputInformation function in the Gui
//					:	pointer to the SetLed Function
//					:	pointer to the int array containing the test flags
//
//Outputs 			:	0 for pass and >0 for error
//=================================================================================//
int TestEntry(DLL_args dllargs)
{
    //----- Local Variables -----//
    int ReturnCode = PASSED;
	//----- The pt2OutFunc variable is a global pointer to a function assigned from input arg===//
	pt2OutFunc= dllargs.pt2OutFunction;   //should not be needed for this dll as we are now using XML Data

    ///------------------------------------------
    starttime = time(NULL);  //Used to start the log of the test time

    //ReturnCode=SetupXMLLogger(dllargs);  //Write the log file header

    if(ReturnCode==PASSED)
        ReturnCode=DisplayDllArgs(dllargs);  //display info on tests if in FA or Debug modes

        //-----------Do any pre test specific items here ----------------

        //-----------End of pre test Specific Items ---------------------

        //----------- Now the tests! ---------------------------------
    if(ReturnCode==PASSED)
    {
        // Startup
        ReturnCode = Init_Test(dllargs);

        // Production Mode
        //============================================================================================//
        //	Test 0 :  TEST ALL
        //============================================================================================//
        if((dllargs.TestArray[0] == 1) && (ReturnCode==PASSED))
        {
            ReturnCode = All_Test(dllargs);
        }
        else
        {
            // Debug Mode
            //============================================================================================//
            //	Test 1 :  BRING-UP TEST
            //============================================================================================//
            if ((dllargs.TestArray[1]==1) && (ReturnCode==PASSED))
            {

                dllargs.pt2LEDFunction(1,LED_TIP);

                if(ReturnCode==PASSED)
                {
                    ReturnCode = Run_Test_1(dllargs);
                    if (ReturnCode!=PASSED)
                    {
                        dllargs.pt2LEDFunction(1,LED_FAILED);
                        ReturnCode = TESTFAILURE;   //overwrite with generic test 1 failure code
                    }
                    else
                    {
                        dllargs.pt2LEDFunction(1,LED_PASSED);
                    }
                }
            }
            //============================================================================================//
            //	Test 2 :  WRITE PATH TEST
            //============================================================================================//
            if ((dllargs.TestArray[2] == 1) && (ReturnCode==PASSED))
            {
                dllargs.pt2LEDFunction(2,LED_TIP);

                if(ReturnCode==PASSED)
                {
                    ReturnCode = Run_Test_2(dllargs);
                    if (ReturnCode!=PASSED)
                    {
                        dllargs.pt2LEDFunction(2,LED_FAILED);
                        ReturnCode = TESTFAILURE;   //overwrite with generic test 2 failure code
                    }
                    else
                    {
                        dllargs.pt2LEDFunction(2,LED_PASSED);
                    }
                }
            }
            //============================================================================================//
            //	Test 3 :  READ PATH TEST
            //============================================================================================//
            if ((dllargs.TestArray[3] == 1) && (ReturnCode==PASSED))
            {
                dllargs.pt2LEDFunction(3,LED_TIP);

                if(ReturnCode==PASSED)
                {
                    ReturnCode = Run_Test_3(dllargs);
                    if (ReturnCode!=PASSED)
                    {
                        dllargs.pt2LEDFunction(3,LED_FAILED);
                        ReturnCode = TESTFAILURE;   //overwrite with generic test 1 failure code
                    }
                    else
                    {
                        dllargs.pt2LEDFunction(3,LED_PASSED);
                    }
                }
            }
            //============================================================================================//
            //	Test 4 :  TAA TEST
            //============================================================================================//
            if ((dllargs.TestArray[4] == 1) && (ReturnCode==PASSED))
            {
                dllargs.pt2LEDFunction(4,LED_TIP);

                if(ReturnCode==PASSED)
                {
                    ReturnCode = Run_Test_4(dllargs);
                    if (ReturnCode!=PASSED)
                    {
                        dllargs.pt2LEDFunction(4,LED_FAILED);
                        ReturnCode = TESTFAILURE;   //overwrite with generic test 4 failure code
                    }
                    else
                    {
                        dllargs.pt2LEDFunction(4,LED_PASSED);
                    }
                }
            }
            //============================================================================================//
            //	Test 5 :  CONNECTIVITY TEST
            //============================================================================================//
            if ((dllargs.TestArray[5]==1) && (ReturnCode==PASSED))
            {
                dllargs.pt2LEDFunction(5,LED_TIP);

                if(ReturnCode==PASSED)
                {
                    ReturnCode = Run_Test_5(dllargs);
                    if (ReturnCode!=PASSED)
                    {
                        dllargs.pt2LEDFunction(5,LED_FAILED);
                        ReturnCode = TESTFAILURE;   //overwrite with generic test 4 failure code
                    }
                    else
                    {
                        dllargs.pt2LEDFunction(5,LED_PASSED);
                    }
                }
            }
        }
        // Tidy Up
        if(Exit_Test(dllargs))
        {

        }
    }
    //--------------End of the tests ---------------------------------

    //-----Anything else below or in the Cleanup_and_Exit() function--

	//Cleanup_and_Exit(ReturnCode);   //make sure we put this before exiting out ! Probably best to ignore any return code errors from
                                    //this function else we could be returning a different number back to the GUI than is put in the
                                    //log file

	return ReturnCode; ////////////if(res =0 green / red)
}

//=================================================================================//
// Function 		:	DisplayDllArgs
// Description		:       Displays the list of tests and number of repeats
//                              requested by the GUI.  Only displayed in debug or
//                              FA modes as dllargs.TestArray[0] always 1 when in
//                              production mode and all other bits ignored in
//                              production mode.
//=================================================================================//
int DisplayDllArgs(DLL_args dllargs)
{
    int ReturnCode = PASSED;

    if(dllargs.TestArray[0]==0)   //0 means FA or Debug
    {
        char TestArray[MAXARGS*2]={0};
        char LoopArray[MAXARGS*2]={0};
        char temp[50];
        //Put the int values into a nice string for debug display (e.g. 0,1,1,0,0, etc)
        for(int i=0;i<MAXARGS;i++)
        {
            if(i<MAXARGS-1)
            {
                sprintf(temp,"%d,",dllargs.TestArray[i]);
                strcat(TestArray,temp);
                sprintf(temp,"%d,",dllargs.LoopArray[i]);
                strcat(LoopArray,temp);
            }
            else
            {
                sprintf(temp,"%d",dllargs.TestArray[i]);
                strcat(TestArray,temp);
                sprintf(temp,"%d",dllargs.LoopArray[i]);
                strcat(LoopArray,temp);
            }
        }

        pXMLLogger->WriteDebugRecord("We are in Debug or FA Mode");
        pXMLLogger->WriteDebugRecord("Tests : %s",TestArray);
        pXMLLogger->WriteDebugRecord("LoopArray : %s",TestArray);
        pXMLLogger->WriteDebugRecord(dllargs.Barcode);
    }

    return ReturnCode;
}


//=================================================================================//
// Function 		:	SetupXMLLogger
// Description		:       Initialises the XML Data Logger and writes the
//                              header info.
//=================================================================================//
int SetupXMLLogger(DLL_args dllargs)
{
    int ReturnCode = PASSED;

    pXMLLogger = new Xy_XML_Data_Logger;   //create memory for the xml data logger

    pXMLLogger->InterProcessComms(dllargs.pMessageClassName);  //pass the main class from the GUI to the XML dll so it knows
                                                                   //where to pass messsages too

    if(dllargs.TestArray[0]==0)             //turn on xyratex data logger if we are in debug mode only
        pXMLLogger->TurnOnOffXyratexLogger(true);

    //Setup and write the XML file header data
    FileHeaderStructure *myHeader = new FileHeaderStructure;

    AnsiString Part_Number,Serial_Number;
    if(strlen(dllargs.Barcode)==17)
    {
        Part_Number = (AnsiString)dllargs.Barcode;
        Part_Number=Part_Number.SubString(1,7)+"-"+ Part_Number.SubString(8,2);
        Serial_Number=(AnsiString)dllargs.Barcode;
        Serial_Number=Serial_Number.SubString(12,6);
    }
    else
    {
        //do what....!?
    }

    myHeader->Description = "MDW 48 Ch Functional Test";   //The name of the test program

    //items from the GUI below
    myHeader->Test_Code=dllargs.TestCode;
    myHeader->Operator=dllargs.Operator;
    myHeader->Test_Station=dllargs.TestRigBarcode;
    myHeader->Retest_Reason=dllargs.RetryReason;
    myHeader->Number_Retry = *dllargs.NumberOfRetries;
    myHeader->RMA=dllargs.RMA;
    myHeader->RMA_LOOP=*dllargs.RMALoop;
    myHeader->Serial_Num=Serial_Number.c_str();
    myHeader->Part_Number=Part_Number.c_str();
    myHeader->Sub_Parts=dllargs.SubParts;
    myHeader->Concessions=dllargs.Concessions;
    myHeader->Comment="";
    ReturnCode=pXMLLogger->WriteHeaderStructure(myHeader);   //write data to the XML generator

    delete myHeader;
    //---- End of the XML file header part ----

    return ReturnCode;
}

//=================================================================================//
// Function 		:	Cleanup_and_Exit
// Description		:	Exit cleanly - free memory - release devices etc
//                              Place all cleanup opeerations here
//=================================================================================//
int Cleanup_and_Exit(int LogFileReturnCode)
{
    int ReturnCode = PASSED;
    char FinalRT[6];
    char Ver[10];
    sprintf(FinalRT,"%05d",LogFileReturnCode);
    sprintf(Ver,"%.2f",DLL_VERSION_NUMBER);

    endtime = time(NULL);
    pXMLLogger->WriteDebugRecord("Test Time = %d secs",endtime-starttime);

    //---- Write the Final Test Report XML Data to File ----
    FinalTestReport *FinalReport = new FinalTestReport;
    FinalReport->Version_Test=Ver;
    FinalReport->Return_Code=FinalRT;
    ReturnCode=pXMLLogger->WriteFinalTestReport(FinalReport);

    delete FinalReport;
    //---- End of XML Write ----
    delete pXMLLogger;  //delete the xml logger

	return ReturnCode;
}


