//#include <Dialogs.hpp>
#include <python.h>
#include "my_py.h"
#include "xylogger.h"
//#include "XMLDataLogger.h"


//The stuff for the dll for dynamic loading
typedef void (*INIT)();
INIT DLL_Py_Initialize;
typedef const char* (*VERSION)();
VERSION DLL_Py_GetVersion;
typedef PyObject* (*STR_STR)(const char*);
STR_STR DLL_PyString_FromString;
typedef PyObject* (*IMPORT_IMPORT)(PyObject*);
IMPORT_IMPORT DLL_PyImport_Import;
typedef PyObject* (*MODULE_DICT)(PyObject*);
MODULE_DICT  DLL_PyModule_GetDict;
typedef PyObject* (*ITEM_STR)(PyObject*, const char*);
ITEM_STR DLL_PyDict_GetItemString;
typedef int (*CALLABLE_CHK)(PyObject*);
CALLABLE_CHK DLL_PyCallable_Check;
typedef PyObject* (*TURPLE_NEW)(Py_ssize_t);
TURPLE_NEW DLL_PyTuple_New;
typedef PyObject* (*INT_FRM_LONG)(long);
INT_FRM_LONG DLL_PyInt_FromLong;
typedef void (*ERR_PRINT)();
ERR_PRINT DLL_PyErr_Print;
typedef int (*TUPLE_ITEM)(PyObject*, Py_ssize_t, PyObject*);
TUPLE_ITEM DLL_PyTuple_SetItem;
typedef PyObject* (*OBJ_OBJ)(PyObject*, PyObject*);
OBJ_OBJ DLL_PyObject_CallObject;
typedef long (*INT_AS_LONG)(PyObject*);
INT_AS_LONG DLL_PyInt_AsLong;
typedef int (*PARSE_TUPLE)(PyObject*, const char*, ...);
PARSE_TUPLE DLL_PyArg_ParseTuple;
typedef int (*RUN_SIMPLE_STR)(const char*);
RUN_SIMPLE_STR DLL_PyRun_SimpleString;
typedef PyObject* (*INIT_MODULE)(char *, PyMethodDef*);
INIT_MODULE DLL_Py_InitModule;
typedef void (*DECREF)(PyObject*);
DECREF DLL_Py_DECREF;
typedef void (*INCREF)(PyObject*);
INCREF DLL_Py_INCREF;
typedef void (*FINALIZE)();
FINALIZE DLL_Py_Finalize;


//extern Xy_XML_Data_Logger* pXMLLogger;

//HINSTANCE
void* dllhandle;

int argc=3;
char *argv[] = {"PSIO_CT\0","my_py_function\0","my_py\0"};
int i;
PyObject *pName, *pModule, *pDict, *pFunc, *pArgs, *pValue;
//************************************************

int py_main()//(int argc, char *argv[])
{
int j=0;
    // Print Params    pipe
    for(j=0; j<argc; j++)
    {
        xyLog(SEV_INFO,"%s",argv[j]);
    }

	if (argc < 3)
	{
		printf("Usage: exe_name python_source function_name\n");
		return 1;
	}

    /* Load the Test library dll*/
    dllhandle = LoadLibrary("python26.dll");

    if (dllhandle != NULL)
    {

        // Load Python functions
        LoadPyFunctions();

        // Init
        DLL_Py_Initialize();

        // Version
        xyLog(SEV_INFO,"Python Version %s",DLL_Py_GetVersion()); //get the dll version but only if it loads ok else we crash!
//        pXMLLogger->WriteTraceData("Python Version %s",DLL_Py_GetVersion());

            // Build the name object
        pName = DLL_PyString_FromString(argv[1]);

        // Load the module object
        pModule = DLL_PyImport_Import(pName);

        // pDict is a borrowed reference
        pDict = DLL_PyModule_GetDict(pModule);

        // pFunc is also a borrowed reference
        pFunc = DLL_PyDict_GetItemString(pDict, argv[2]);

        if (DLL_PyCallable_Check(pFunc))
        {
            // Prepare the argument list for the call
            if( argc > 3 )
            {
                pArgs = DLL_PyTuple_New(argc - 3);
                for (i = 0; i < argc - 3; i++)
                {
                    pValue = DLL_PyInt_FromLong(atoi(argv[i + 3]));
                    if (!pValue)
                    {
                        DLL_PyErr_Print();
                        return 1;
                    }
                    DLL_PyTuple_SetItem(pArgs, i, pValue);
                }

                pValue = DLL_PyObject_CallObject(pFunc, pArgs);

                if (pArgs != NULL)
                {
                    DLL_Py_DECREF(pArgs);
                }
            }
            else
            {
                pValue = DLL_PyObject_CallObject(pFunc, NULL);
            }

            if (pValue != NULL)
            {
                xyLog(SEV_INFO,"Return of call : %d\n", DLL_PyInt_AsLong(pValue));
                DLL_Py_DECREF(pValue);
            }
            else
            {
                DLL_PyErr_Print();
                xyLog(SEV_INFO,"Error in call");
            }
        }
        else
        {
            DLL_PyErr_Print();
            xyLog(SEV_INFO,"Error in call");
        }
        // Clean up
        DLL_Py_DECREF(pModule);
        DLL_Py_DECREF(pName);

        // Finish the Python Interpreter
        DLL_Py_Finalize();
    }
    else
    {
        xyLog(SEV_INFO,"Failed to launch test dll (python26)\nMissing file?");
    }

}

void LoadPyFunctions()
{
        // Get Initialize fn
        DLL_Py_Initialize = (INIT) GetProcAddress(dllhandle, "Py_Initialize"); //borland
        if(DLL_Py_Initialize == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_Initialize Failed!");
        // Get Version fn
        DLL_Py_GetVersion = (VERSION) GetProcAddress(dllhandle, "Py_GetVersion"); //borland
        if(DLL_Py_GetVersion == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_GetVersion Failed!");
        // Get StrFromStr fn
        DLL_PyString_FromString = (STR_STR) GetProcAddress(dllhandle, "PyString_FromString"); //borland
        if(DLL_PyString_FromString == NULL)
            xyLog(SEV_INFO,"Get PyString_FromString Failed!");
        // Get PyImport_Import fn
        DLL_PyImport_Import = (IMPORT_IMPORT) GetProcAddress(dllhandle, "PyImport_Import"); //borland
        if(DLL_PyImport_Import == NULL)
            xyLog(SEV_INFO,"Get PyImport_Import Failed!");
        // Get PyModule_GetDict fn
        DLL_PyModule_GetDict = (MODULE_DICT) GetProcAddress(dllhandle, "PyModule_GetDict"); //borland
        if(DLL_PyModule_GetDict == NULL)
            xyLog(SEV_INFO,"Get PyModule_GetDict Failed!");
        // Get PyDict_GetItemString fn
        DLL_PyDict_GetItemString = (ITEM_STR) GetProcAddress(dllhandle, "PyDict_GetItemString"); //borland
        if(DLL_PyDict_GetItemString == NULL)
            xyLog(SEV_INFO,"Get PyDict_GetItemString Failed!");
        // Get PyCallable_Check fn
        DLL_PyCallable_Check = (CALLABLE_CHK) GetProcAddress(dllhandle, "PyCallable_Check"); //borland
        if(DLL_PyCallable_Check == NULL)
            xyLog(SEV_INFO,"Get PyCallable_Check Failed!");
        // Gert PyTuple_New fn
        DLL_PyTuple_New = (TURPLE_NEW) GetProcAddress(dllhandle, "PyTuple_New"); //borland
        if(DLL_PyTuple_New == NULL)
            xyLog(SEV_INFO,"Get PyTuple_New Failed!");
        // Gert PyInt_FromLongPyInt_FromLong fn
        DLL_PyInt_FromLong = (INT_FRM_LONG) GetProcAddress(dllhandle, "PyInt_FromLong"); //borland
        if(DLL_PyInt_FromLong == NULL)
            xyLog(SEV_INFO,"Get PyInt_FromLong Failed!");
        // Gert PyErr_Print fn
        DLL_PyErr_Print = (ERR_PRINT) GetProcAddress(dllhandle, "PyErr_Print"); //borland
        if(DLL_PyErr_Print == NULL)
            xyLog(SEV_INFO,"Get PyErr_Print Failed!");
        // Gert PyTuple_SetItem fn
        DLL_PyTuple_SetItem = (TUPLE_ITEM) GetProcAddress(dllhandle, "PyTuple_SetItem"); //borland
        if(DLL_PyTuple_SetItem == NULL)
            xyLog(SEV_INFO,"Get PyTuple_SetItem Failed!");
        // Gert PyObject_CallObject fn
        DLL_PyObject_CallObject = (OBJ_OBJ) GetProcAddress(dllhandle, "PyObject_CallObject"); //borland
        if(DLL_PyObject_CallObject == NULL)
            xyLog(SEV_INFO,"Get PyObject_CallObject Failed!");
        // Gert PyInt_AsLong fn
        DLL_PyInt_AsLong = (INT_AS_LONG) GetProcAddress(dllhandle, "PyInt_AsLong"); //borland
        if(DLL_PyInt_AsLong == NULL)
            xyLog(SEV_INFO,"Get PyObject_CallObject Failed!");
        // Gert PyArg_ParseTuple fn
        DLL_PyArg_ParseTuple = (FINALIZE) GetProcAddress(dllhandle, "PyArg_ParseTuple"); //borland
        if(DLL_PyArg_ParseTuple == NULL)
            xyLog(SEV_INFO,"Get PyArg_ParseTuple Failed!");
        // Gert PyRun_SimpleString fn
        DLL_PyRun_SimpleString = (FINALIZE) GetProcAddress(dllhandle, "PyRun_SimpleString"); //borland
        if(DLL_PyRun_SimpleString == NULL)
            xyLog(SEV_INFO,"Get PyRun_SimpleString Failed!");
        // Gert DLL_Py_InitModule fn
        DLL_Py_InitModule = (FINALIZE) GetProcAddress(dllhandle, "DLL_Py_InitModule"); //borland
        if(DLL_Py_InitModule == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_InitModule Failed!");
        // Gert DLL_Py_DECREF fn
        DLL_Py_DECREF = (FINALIZE) GetProcAddress(dllhandle, "DLL_Py_DECREF"); //borland
        if(DLL_Py_DECREF == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_DECREF Failed!");
        // Gert DLL_Py_INCREF fn
        DLL_Py_INCREF = (FINALIZE) GetProcAddress(dllhandle, "DLL_Py_INCREF"); //borland
        if(DLL_Py_INCREF == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_INCREF Failed!");
        // Gert DLL_Py_Finalize fn
        DLL_Py_Finalize = (FINALIZE) GetProcAddress(dllhandle, "DLL_Py_Finalize"); //borland
        if(DLL_Py_Finalize == NULL)
            xyLog(SEV_INFO,"Get DLL_Py_Finalize Failed!");
}            
            
PyObject* log_CaptureStdout(PyObject* self, PyObject* pArgs)
{
        char* LogStr = NULL;
        if (!PyArg_ParseTuple(pArgs, "s", &LogStr))
                return NULL;

        xyLog(0,"%s", LogStr);
        // Simply using printf to do the real work.
        // You could also write it to a .log file or whatever...
        // MessageBox(NULL, LogStr...
        // WriteFile(hFile, LogStr...

        DLL_Py_INCREF(Py_None);
        return Py_None;
}

// Notice we have STDERR too.
PyObject* log_CaptureStderr(PyObject* self, PyObject* pArgs)
{ 
        char* LogStr = NULL;
        if (!PyArg_ParseTuple(pArgs, "s", &LogStr))
                return NULL;

        xyLog(0,"%s", LogStr);

        DLL_Py_INCREF(Py_None);
        return Py_None;
} 
 
static PyMethodDef logMethods[] = { 
 {"CaptureStdout", log_CaptureStdout, METH_VARARGS, "Logs stdout"}, 
 {"CaptureStderr", log_CaptureStderr, METH_VARARGS, "Logs stderr"},
 {NULL, NULL, 0, NULL}
};

#if 0
 DLL_Py_InitModule("log", logMethods);
 PyRun_SimpleString(
"import log\n"
"import sys\n"
"class StdoutCatcher:\n"
"\tdef write(self, str):\n"
"\t\tlog.CaptureStdout(str)\n"
"class StderrCatcher:\n"
"\tdef write(self, str):\n"
"\t\tlog.CaptureStderr(str)\n"
"sys.stdout = StdoutCatcher()\n"
"sys.stderr = StderrCatcher()\n"
);
Now everything that should be written to stdout will be written on the console(in our case) window. The Python code we actually
running is simply to change the class of stdoud:
import log
import sys
class StdoutCatcher:
  def write(self, str):
    tlog.CaptureStdout(str)

class StderrCatcher:
  def write(self, str):
    log.CaptureStderr(str)

sys.stdout = StdoutCatcher() // Create a class object
sys.stderr = StderrCatcher() // Ditto
#endif