//****************************************************************************//
// FILENAME:    MY_PY.H                                                     //
//                                                                            //
// DESCRIPTION:                                                               //
//                                                                            //
// DATE:                                                                      //
//****************************************************************************//
#ifndef MY_PY_H    // standard protection against multiple inclusion
#define MY_PY_H
//****************************************************************************//
// PYTHON V2.6 DLL FUNCTION 'TYPEDEF'
//****************************************************************************//
typedef void (*INIT)();
typedef const char* (*VERSION)();
typedef PyObject* (*STR_STR)(const char*);
typedef PyObject* (*IMPORT_IMPORT)(PyObject*);
typedef PyObject* (*MODULE_DICT)(PyObject*);
typedef PyObject* (*ITEM_STR)(PyObject*, const char*);
typedef int (*CALLABLE_CHK)(PyObject*);
typedef PyObject* (*TURPLE_NEW)(Py_ssize_t);
typedef PyObject* (*INT_FRM_LONG)(long);
typedef void (*ERR_PRINT)();
typedef int (*TUPLE_ITEM)(PyObject*, Py_ssize_t, PyObject*);
typedef PyObject* (*OBJ_OBJ)(PyObject*, PyObject*);
typedef long (*INT_AS_LONG)(PyObject*);
typedef int (*PARSE_TUPLE)(PyObject*, const char*, ...);
typedef int (*RUN_SIMPLE_STR)(const char*);
typedef PyObject* (*INIT_MODULE_PY)(char*,PyMethodDef*,char*,PyObject *,int);
typedef void (*DECREF_PY)(PyObject*);
typedef void (*INCREF_PY)(PyObject*);
typedef void (*FINALIZE)();
typedef PyObject (*NONE_PY);
typedef PyObject* (*BUILD_VALUE)(const char *format, ...);


//****************************************************************************//
// STATIC (LCOAL) FUNCTION PROTOTYPES
//****************************************************************************//
static void LoadPyFunctions(void);
static PyObject* log_CaptureStderr(PyObject* self, PyObject* pArgs);
static PyObject* log_CaptureStdout(PyObject* self, PyObject* pArgs);
static PyObject* log_CaptureStdin(PyObject* self, PyObject* pArgs);





static PyObject* log_UDP_Enable(PyObject* self, PyObject* pArgs);
static PyObject* log_UDP_Disable(PyObject* self, PyObject* pArgs);
static PyObject* log_Sockets_Enable(PyObject* self, PyObject* pArgs);
static PyObject* log_Sockets_Disable(PyObject* self, PyObject* pArgs);
static PyObject* log_InterProcessComms(PyObject* self, PyObject* pArgs);
static PyObject* log_TurnOnOffXyratexLogger(PyObject* self, PyObject* pArgs);
static PyObject* log_Version(PyObject* self, PyObject* pArgs);
static PyObject* log_AbortXMLLog(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteXMLLogtoLocation(PyObject* self, PyObject* pArgs);
static PyObject* log_GetXMLLogLocation(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteHeaderStructure(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteTestHeader(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteTestReport(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteFinalTestReport(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteAnalogueMeasurement(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteDigitalMeasurement(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteDebugRecord(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteToXyLoggerOnly(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteTraceData(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteTableRecordHeader(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteTableRow(PyObject* self, PyObject* pArgs);
static PyObject* log_EndTableRecord(PyObject* self, PyObject* pArgs);
static PyObject* log_WriteNonStandardRecord(PyObject* self, PyObject* pArgs);

//****************************************************************************//
// GLOBAL FUNCTION PROTOTYPES
//****************************************************************************//
int py_main(    char* PyEnv,
                char* PyModule,
                char* PyFn,
                int (*pt2OutFunction)(int, char *Text,...),
                char *PartNumber,
                char *SerialNumber,
                char *Concessions,
                char *TestCode,
                char *Operator,
                char *TestRigBarcode,
                char *LogFilePath,
                char *LogFileName );

PyMODINIT_FUNC initlog(void);                
#endif
