//****************************************************************************//
// FILENAME:    TEST.CPP                                                      //
//                                                                            //
// DESCRIPTION:                                                               //
//                                                                            //
// DATE:                                                                      //
//****************************************************************************//
#include <python.h>
#include "test.h"
#include "Limits.h"
#include "error_codes.h"
#include "XMLDataLogger.h"
#include "dir.h"
#include <process.h>
#include "my_py.h"

//****************************************************************************//
// EXTERNAL GLOBAL VARIABLES
//****************************************************************************//

//****************************************************************************//
// LOCAL GLOBAL VARIABLES
//****************************************************************************//
static char * const argv_Init[]       = {"MDW\0",    "ProductTestInit\0",        "ProductTestInit\0"     };
static char * const argv_All[]        = {"MDW\0",    "ProductTestAll\0",         "ProductTestAll\0"      };
static char * const argv_Exit[]       = {"MDW\0",    "ProductTestExit\0",        "ProductTestExit\0"     };
static char * const argv_BringUp[]    = {"MDW\0",    "ProductTestBringUp\0",     "ProductTestBringUp\0"  };
static char * const argv_WritePath[]  = {"MDW\0",    "ProductTestWritePath\0",   "ProductTestWritePath\0"};
static char * const argv_ReadPath[]   = {"MDW\0",    "ProductTestReadPath\0",    "ProductTestReadPath\0" };
static char * const argv_TAA[]        = {"MDW\0",    "ProductTestTAA\0",         "ProductTestTAA\0"      };
static char * const argv_Connect[]    = {"MDW\0",    "ProductTestConnect\0",     "ProductTestConnect\0"  };


static int GetPartandSerialNumberFromBarcode(char* Barcode);

static AnsiString Part_Number;
static AnsiString Serial_Number;
static char* PartNumber =  NULL;
static char* SerialNumber = NULL;


//****************************************************************************//
// GLOBAL VARIABLES
//****************************************************************************//


//****************************************************************************//
// Function Name:   Init_Test()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Init_Test(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

    return py_main( argv_Init[0],
                    argv_Init[1],
                    argv_Init[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Exit_Test()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Exit_Test(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

    return py_main( argv_Exit[0],
                    argv_Exit[1],
                    argv_Exit[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Exit_Test()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int All_Test(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

    return py_main( argv_All[0],
                    argv_All[1],
                    argv_All[2],
                    dllargs.pt2OutFunction,
                    dllargs.Barcode,
                    dllargs.SubParts,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Run_Test_1()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Run_Test_1( DLL_args dllargs )
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

	return py_main( argv_BringUp[0],
                    argv_BringUp[1],
                    argv_BringUp[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName);
}

//****************************************************************************//
// Function Name:   Run_Test_2()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Run_Test_2(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

	return py_main( argv_WritePath[0],
                    argv_WritePath[1],
                    argv_WritePath[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Run_Test_3()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Run_Test_3(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

	return py_main( argv_ReadPath[0],
                    argv_ReadPath[1],
                    argv_ReadPath[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Run_Test_4()
// Paramater:       DLL_args dllargs
// Return Value:    int
//
// Description:
//****************************************************************************//
int Run_Test_4(DLL_args dllargs)
{
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

	return py_main( argv_TAA[0],
                    argv_TAA[1],
                    argv_TAA[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );
}

//****************************************************************************//
// Function Name:   Run_Test_5()
// Paramater:       void
// Return Value:    int
//
// Description:
//****************************************************************************//
int Run_Test_5(DLL_args dllargs)
{
    return 0;
    /*
    GetPartandSerialNumberFromBarcode(dllargs.Barcode);

	return py_main( argv_Connect[0],
                    argv_Connect[1],
                    argv_Connect[2],
                    dllargs.pt2OutFunction,
                    PartNumber,
                    SerialNumber,
                    dllargs.Concessions,
                    dllargs.TestCode,
                    dllargs.Operator,
                    dllargs.TestRigBarcode,
                    dllargs.LogFilePath,
                    dllargs.LogFileName );*/
}

//****************************************************************************//
// Function Name:   GetPartandSerialNumberFromBarcode()
// Paramater:       char* Barcode, char* PartNumber, char * SerialNumber
// Return Value:    int
//
// Description:
//****************************************************************************//
int GetPartandSerialNumberFromBarcode(char* Barcode)
{
    if(strlen(Barcode)==17)
    {
        Part_Number = (AnsiString)Barcode;
        Part_Number = Part_Number.SubString(1,7)+"-"+ Part_Number.SubString(8,2);
        Serial_Number = (AnsiString)Barcode;
        Serial_Number = Serial_Number.SubString(12,6);
    }
    else
    {
        //do what....!?
    }

    SerialNumber = Serial_Number.c_str();
    PartNumber = Part_Number.c_str();

    return 0;
}
